<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;
use Teknisa\MAN\Utilities;
use Teknisa\MAN\Services\RelObservacaoCancelamentoService;

class RelObservacaoCancelamento extends CrudWithParameterBag{
    
    public function __construct (Manager $dataSourceManager, ParameterBag $parameterBag, Utilities\Util $utilService, RelObservacaoCancelamentoService $RelObservacaoCancelamentoService) {
        $this->utilService = $utilService;
        $this->reportService = $RelObservacaoCancelamentoService;
    }
    
    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        $conditions = $this->utilService->getParamsAsArray($request);
        if( array_key_exists('DTENTRVENDA', $conditions) ) {
            $conditions['DTINI'] = $conditions['DTENTRVENDA'][0];
            $conditions['DTFIN'] = $conditions['DTENTRVENDA'][1];
            unset($conditions['DTENTRVENDA']);
        }
        if(!array_key_exists('CDFILIAL', $conditions) ) {
            $conditions['TCDFILIAL'] = 'T';
            $conditions['CDFILIAL'] = null;
        }else{
            $conditions['CDFILIAL'] = implode($conditions['CDFILIAL'], '_');
            $conditions['TCDFILIAL'] = null;
        }
        if(!array_key_exists('CDLOJA', $conditions) ) {
            $conditions['TCDLOJA'] = 'T';
            $conditions['CDLOJA'] = null;
        }else{
             $conditions['CDLOJA'] = implode($conditions['CDLOJA'], '_');
             $conditions['TCDLOJA'] = null;
        }
        $result = $this->reportService->fetchReport($conditions);
        $response->addDataSet(new DataSet("vnd0160D_relObservacaoCancelamento", $result));
        return $response;
    }
}